DROP TRIGGER IF EXISTS trigger_flag ON osm_lm_polygon;
DROP TRIGGER IF EXISTS trigger_refresh ON lm_polygon.updates;

-- etldoc:  osm_lm_polygon ->  osm_lm_polygon

CREATE OR REPLACE FUNCTION update_lm_polygon() RETURNS void AS
$$
BEGIN
    UPDATE osm_lm_polygon
    SET geometry =
            CASE
                WHEN ST_NPoints(ST_ConvexHull(geometry)) = ST_NPoints(geometry)
                    THEN ST_Centroid(geometry)
                ELSE ST_PointOnSurface(geometry)
                END
    WHERE ST_GeometryType(geometry) <> 'ST_Point';

    UPDATE osm_lm_polygon
    SET subclass = 'subway'
    WHERE station = 'subway'
      AND subclass = 'station';

    UPDATE osm_lm_polygon
    SET subclass = 'halt'
    WHERE funicular = 'yes'
      AND subclass = 'station';

    UPDATE osm_lm_polygon
    SET tags = update_tags(tags, geometry)
    WHERE COALESCE(tags->'name:latin', tags->'name:nonlatin', tags->'name_int') IS NULL;

    ANALYZE osm_lm_polygon;
END;
$$ LANGUAGE plpgsql;

SELECT update_lm_polygon();

-- Handle updates

CREATE SCHEMA IF NOT EXISTS lm_polygon;

CREATE TABLE IF NOT EXISTS lm_polygon.updates
(
    id serial PRIMARY KEY,
    t  text,
    UNIQUE (t)
);
CREATE OR REPLACE FUNCTION lm_polygon.flag() RETURNS trigger AS
$$
BEGIN
    INSERT INTO lm_polygon.updates(t) VALUES ('y') ON CONFLICT(t) DO NOTHING;
    RETURN NULL;
END;
$$ LANGUAGE plpgsql;

CREATE OR REPLACE FUNCTION lm_polygon.refresh() RETURNS trigger AS
$$
BEGIN
    RAISE LOG 'Refresh lm_polygon';
    PERFORM update_lm_polygon();
    -- noinspection SqlWithoutWhere
    DELETE FROM lm_polygon.updates;
    RETURN NULL;
END;
$$ LANGUAGE plpgsql;

CREATE TRIGGER trigger_flag
    AFTER INSERT OR UPDATE OR DELETE
    ON osm_lm_polygon
    FOR EACH STATEMENT
EXECUTE PROCEDURE lm_polygon.flag();

CREATE CONSTRAINT TRIGGER trigger_refresh
    AFTER INSERT
    ON lm_polygon.updates
    INITIALLY DEFERRED
    FOR EACH ROW
EXECUTE PROCEDURE lm_polygon.refresh();
